<?php

namespace Drupal\opensearch_views\Plugin\views\field;

use Drupal\views\Plugin\views\field\FieldPluginBase;
use Drupal\views\ResultRow;

/**
 * Field handler for OpenSearch metadata fields (ID, score).
 *
 * @ViewsField("opensearch_field")
 */
class OpenSearchField extends FieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function query() {
    // We don't need to add anything to the query.
  }

  /**
   * {@inheritdoc}
   */
  public function render(ResultRow $row) {
    $field = $this->field;
    
    switch ($field) {
      case 'id':
        return $row->opensearch_id;
        
      case 'score':
        return $row->opensearch_score;
        
      default:
        return '';
    }
  }
}
