<?php

namespace Drupal\opensearch_views\Plugin\views\filter;

use Drupal\views\Plugin\views\filter\StringFilter;

/**
 * Filter handler for OpenSearch metadata fields.
 *
 * @ViewsFilter("opensearch_filter")
 */
class OpenSearchFilter extends StringFilter {

  /**
   * {@inheritdoc}
   */
  public function query() {
    $this->ensureMyTable();
    
    $field = $this->field;
    
    // Map operator to OpenSearch query types.
    $operator = $this->operator;
    
    if ($operator === 'contains') {
      $operator = 'contains';
    }
    elseif ($operator === 'starts') {
      $operator = 'starts';
    }
    elseif ($operator === 'ends') {
      $operator = 'ends';
    }
    elseif ($operator === 'word') {
      // For word boundary, use contains.
      $operator = 'contains';
    }
    
    $this->query->addWhere($this->options['group'], $field, $this->value, $operator);
  }
}
